package jp.frost.convertunicode;

public class ConvertUnicode {
	public static String convertUnicode(String str) {
		int index = 0;
		int len = str.length();
		char hChar=0;
		char aChar;
		char[] out = new char[len*2];
		int outLen = 0;

		while (index < len) {
			aChar = str.charAt(index++);
			if (aChar == '\\') {
				aChar = str.charAt(index++);
				if(aChar == 'u') {
					// Read the xxxx
					int value=0;
					for (int i=0; i<4; i++) {
						aChar = str.charAt(index++);
						switch (aChar) {
							case '0': case '1': case '2': case '3': case '4':
							case '5': case '6': case '7': case '8': case '9':
								value = (value << 4) + aChar - '0';
								break;
							case 'a': case 'b': case 'c':
							case 'd': case 'e': case 'f':
								value = (value << 4) + 10 + aChar - 'a';
								break;
							case 'A': case 'B': case 'C':
							case 'D': case 'E': case 'F':
								value = (value << 4) + 10 + aChar - 'A';
								break;
							default:
								throw new IllegalArgumentException(
										"Malformed \\uxxxx encoding.");
						}
					}
					char lChar = (char)value;
					out[outLen++] = lChar;
					if(Character.isSurrogatePair(hChar, lChar)){
						outLen--;
						char[] sc = Character.toChars(Character.toCodePoint(hChar, lChar));
						hChar = 0;
						for(int i=0;i<sc.length;i++){
							out[outLen++] = sc[i];
						}
					}
					hChar = lChar;
				} else {
					if (aChar == 't') aChar = '\t';
					else if (aChar == 'r') aChar = '\r';
					else if (aChar == 'n') aChar = '\n';
					else if (aChar == 'f') aChar = '\f';
					out[outLen++] = aChar;
				}
			} else {
				out[outLen++] = (char)aChar;
			}
		}

		return new String (out, 0, outLen);
	}
}
