package jp.hishidama.eval;

import static jp.hishidama.eval.EvalException.*;

/**
 * ZG[bZ[WҏWNX.
 * <p>
 * {@link EvalException}p̃G[bZ[WҏWB
 * </p>
 *
 * @author <a target="hishidama"
 *         href="http://www.ne.jp/asahi/hishidama/home/tech/soft/java/eval16.html"
 *         >Ђ</a>
 * @since eval16
 */
public class EvalExceptionFormatter {

	private static EvalExceptionFormatter me;

	/**
	 * ftHgtH[}b^[擾
	 *
	 * @return tH[}b^[
	 */
	public static EvalExceptionFormatter getDefault() {
		if (me == null) {
			me = new EvalExceptionFormatter();
		}
		return me;
	}

	/**
	 * G[bZ[W.
	 * <p>
	 * {@link EvalException}̃G[bZ[W𐶐B
	 * </p>
	 *
	 * @param e
	 *            O
	 * @return G[bZ[W
	 * @see EvalException#toString()
	 */
	public String toString(EvalException e) {
		String msg = getErrCodeMessage(e.getErrorCode());
		String fmt = getFormat(e, msg);
		return toString(e, fmt);
	}

	/**
	 * R[hʃbZ[W擾
	 *
	 * @param code
	 *            G[R[h
	 * @return 僁bZ[WitH[}bgtj
	 */
	public String getErrCodeMessage(int code) {
		switch (code) {
		case PARSE_NOT_FOUND_END_OP:
			return "Zqu%0v݂܂B";
		case PARSE_INVALID_OP:
			return "Zq̕@G[łB";
		case PARSE_INVALID_CHAR:
			return "Ή̎ʎqłB";
		case PARSE_END_OF_STR:
			return "̉߂̓rŕ񂪏IĂ܂B";
		case PARSE_STILL_EXIST:
			return "̉߂I܂񂪎cĂ܂B";
		case PARSE_NOT_FUNC:
			return "֐ƂĎgpł܂B";
		case EXP_FORBIDDEN_CALL:
			return "֎~Ă郁\bhĂяo܂B";
		case EXP_NOT_VARIABLE:
			return "ϐƂĎgpł܂B";
		case EXP_NOT_NUMBER:
			return "lƂĎgpł܂B";
		case EXP_NOT_LET:
			return "ł܂B";
		case EXP_NOT_CHAR:
			return "ƂĎgpł܂B";
		case EXP_NOT_STRING:
			return "ƂĎgpł܂B";
		case EXP_NOT_VAR_VALUE:
			return "ϐ̒l擾ł܂B";
		case EXP_NOT_LET_VAR:
			return "ϐɑł܂B";
		case EXP_NOT_DEF_VAR:
			return "ϐ`łB";
		case EXP_NOT_DEF_OBJ:
			return "IuWFNg`łB";
		case EXP_NOT_ARR_VALUE:
			return "z̒l擾ł܂B";
		case EXP_NOT_LET_ARR:
			return "zɑł܂B";
		case EXP_NOT_FLD_VALUE:
			return "tB[h̒l擾ł܂B";
		case EXP_NOT_LET_FIELD:
			return "tB[hɑł܂B";
		case EXP_FUNC_CALL_ERROR:
			return "֐̌ĂяoɎs܂B";
		default:
			return "G[܂B";
		}
	}

	/**
	 * tH[}bg擾
	 *
	 * @param e
	 *            O
	 * @param msgFmt
	 *            僁bZ[W
	 * @return bZ[WtH[}bg
	 */
	public String getFormat(EvalException e, String msgFmt) {
		StringBuilder fmt = new StringBuilder(128);
		fmt.append(msgFmt);

		String word = e.getWord();
		String string = e.getString();

		boolean bWord = false;
		if (word != null && word.length() > 0) {
			bWord = true;
			if (word.equals(string)) {
				bWord = false;
			}
		}
		if (bWord) {
			fmt.append(" %n=u%wv");
		}

		int pos = e.getPos();
		if (pos >= 0) {
			fmt.append(" pos=%p");
		}
		if (string != null) {
			fmt.append(" string=u%sv");
		}
		if (e.getCause() != null) {
			fmt.append(" cause by %e");
		}

		return fmt.toString();
	}

	/**
	 * G[bZ[W擾.
	 * <p>
	 * tH[}bgɃbZ[WҏWB
	 * <table border="1">
	 * <tr>
	 * <td>%0`9</td>
	 * <td>t0`9ԁB݂Ȃꍇ͋󕶎</td>
	 * </tr>
	 * <tr>
	 * <td>%c</td>
	 * <td>G[R[h</td>
	 * </tr>
	 * <tr>
	 * <td>%n</td>
	 * <td>͖</td>
	 * </tr>
	 * <tr>
	 * <td>%s</td>
	 * <td>͑O̕</td>
	 * </tr>
	 * <tr>
	 * <td>%p</td>
	 * <td>G[A͑Öʒu</td>
	 * </tr>
	 * <tr>
	 * <td>%w</td>
	 * <td>G[̌ƂȂ</td>
	 * </tr>
	 * <tr>
	 * <td>%e</td>
	 * <td>炩̗OŃG[ƂȂꍇ́A̗O</td>
	 * </tr>
	 * <tr>
	 * <td>%%</td>
	 * <td>u%v</td>
	 * </tr>
	 * </table>
	 * </p>
	 *
	 * @param e
	 *            O
	 * @param format
	 *            tH[}bg
	 * @return G[bZ[W
	 */
	public String toString(EvalException e, String format) {
		StringBuilder sb = new StringBuilder(256);
		int len = format.length();
		for (int i = 0; i < len; i++) {
			char c = format.charAt(i);
			if (c != '%') {
				sb.append(c);
			} else {
				if (i + 1 >= len) {
					sb.append(c);
					break;
				}
				c = format.charAt(++i);
				switch (c) {
				case '0':
				case '1':
				case '2':
				case '3':
				case '4':
				case '5':
				case '6':
				case '7':
				case '8':
				case '9': {
					int n = c - '0';
					String[] msgOpt = e.getOption();
					if (msgOpt != null && n < msgOpt.length) {
						sb.append(msgOpt[n]);
					} else {
						sb.append('%');
						sb.append(c);
					}
					break;
				}
				case 'c':
					sb.append(e.getErrorCode());
					break;
				case 'n':
					sb.append(e.getExpressionName());
					break;
				case 'w':
					sb.append(e.getWord());
					break;
				case 'p':
					sb.append(e.getPos());
					break;
				case 's':
					sb.append(e.getString());
					break;
				case 'e':
					sb.append(e.getCause());
					break;
				case '%':
					sb.append('%');
					break;
				default:
					sb.append('%');
					sb.append(c);
					break;
				}
			}
		}
		return sb.toString();
	}
}
